/*
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IOSOCKET_DEFINED
#define IOSOCKET_DEFINED 1

#include "IoObject.h"
#include "IoSeq.h"
#include "IoSeq.h"
#include "Socket.h"

#define ISSOCKET(self) IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoSocket_rawClone)

typedef IoObject IoSocket;

typedef struct
{
  Socket *socket;
  void *ioSocketManager;
  IoSeq *buffer;
} IoSocketData;

IoSocket *IoSocket_rawClone(IoSocket *self);
IoSocket *IoSocket_proto(void *state);
IoSocket *IoSocket_new(void *state);
IoSocket *IoSocket_newWithDescriptor_address_(void *state, int descriptor, struct sockaddr *address);
IoSocket *IoSocket_newWithSocket_(void *state, Socket *socket);
void IoSocket_free(IoSocket *self);
void IoSocket_mark(IoSocket *self);

/* ----------------------------------------------------------- */
IoObject *IoSocket_host(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_host_(IoSocket *self, IoObject *locals, IoMessage *m);

IoObject *IoSocket_port(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_port_(IoSocket *self, IoObject *locals, IoMessage *m);

IoObject *IoSocket_readSize(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_readSize_(IoSocket *self, IoObject *locals, IoMessage *m);

IoObject *IoSocket_readTimeout(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_readTimeout_(IoSocket *self, IoObject *locals, IoMessage *m);

IoObject *IoSocket_connectTimeout(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_setConnectTimeout(IoSocket *self, IoObject *locals, IoMessage *m);

IoObject *IoSocket_openFifo_(IoSocket *self, IoObject *locals, IoMessage *m); /* for files */

IoObject *IoSocket_udpOpen(IoSocket *self, IoObject *locals, IoMessage *m);
/*
IoObject *IoSocket_udpWrite(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_udpRead(IoSocket *self, IoObject *locals, IoMessage *m);
*/
IoObject *IoSocket_udpFromIP(IoSocket *self, IoObject *locals, IoMessage *m);

IoObject *IoSocket_connect(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_isOpen(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_read(IoSocket *self, IoObject *locals, IoMessage *m);

IoObject *IoSocket_write(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_close(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_buffer(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_error(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_clearError(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_transferRate(IoSocket *self, IoObject *locals, IoMessage *m);

/* --- Server ---------- */
IoObject *IoSocket_serverOpen(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_serverWaitForConnection(IoSocket *self, IoObject *locals, IoMessage *m);

#endif
