/*
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IOSOCKETMANAGER_DEFINED
#define IOSOCKETMANAGER_DEFINED 1

#include "IoObject.h"
#include "IoSeq.h"
#include "SocketManager.h"
#include "event.h"

#define ISSOCKETMANAGER(self) \
  IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoSocketManager_rawClone)

typedef IoObject IoSocketManager;

typedef struct
{
    SocketManager *socketManager;
} IoSocketManagerData;

IoSocketManager *IoSocketManager_socketManagerForState_(void *state);

IoSocketManager *IoSocketManager_rawClone(IoSocketManager *self);
IoSocketManager *IoSocketManager_proto(void *state);
void IoSocketManager_mark(IoSocketManager *self);
void IoSocketManager_free(IoSocketManager *self);
SocketManager *IoSocketManager_rawSocketManager(IoSocketManager *self);

void IoSocketManager_update(IoSocketManager *self);

/* --- methods --- */

IoObject *IoSocketManager_clone(IoSocketManager *self, IoObject *locals, IoMessage *m);
IoObject *IoSocketManager_descriptorCount(IoSocketManager *self, IoObject *locals, IoMessage *m);
IoObject *IoSocketManager_setSelectTimeout(IoSocketManager *self, IoObject *locals, IoMessage *m);
IoObject *IoSocketManager_selectTimeout(IoSocketManager *self, IoObject *locals, IoMessage *m);
IoObject *IoSocketManager_run(IoSocketManager *self, IoObject *locals, IoMessage *m);

#endif
