#!/bin/sh

setup () {
	 EVENT_NOKQUEUE=yes
	 EVENT_NODEVPOLL=yes
	 EVENT_NOPOLL=yes
	 EVENT_NOSELECT=yes
	 EVENT_NOEPOLL=yes
	 EVENT_NORTSIG=yes
	 export EVENT_NOKQUEUE
	 export EVENT_NODEVPOLL
	 export EVENT_NOPOLL
	 export EVENT_NOSELECT
	 export EVENT_NOEPOLL
	 export EVENT_NORTSIG
}

test () {
	./test-init >/dev/null
  if [ $? != 0 ]
	then
		echo Skipping test
		return
	fi	

echo " test-eof: \c"
./test-eof >/dev/null
if [ $? = 0 ]; then 
	echo OKAY ; 
else 
	echo FAILED ; 
fi
echo " test-weof: \c"
./test-weof >/dev/null
if [ $? = 0 ]; then
	echo OKAY ; 
else 
	echo FAILED ; 
fi
echo " test-time: \c"
./test-time >/dev/null
if [ $? = 0 ]; then 
	echo OKAY ; 
else 
	echo FAILED ; 
fi
echo " regress: \c"
./regress >/dev/null
if [ $? = 0 ]; then
	echo OKAY ; 
else 
	echo FAILED ; 
fi
}

echo "Running tests:"

# Need to do this by hand?
setup
unset EVENT_NOKQUEUE
echo "KQUEUE"
test

setup
unset EVENT_NODEVPOLL
echo "DEVPOLL"
test

setup
unset EVENT_NOPOLL
echo "POLL"
test

setup
unset EVENT_NOSELECT
echo "SELECT"
test

setup
unset EVENT_NORTSIG
echo "RTSIG"
test

setup
unset EVENT_NOEPOLL
echo "EPOLL"
test



