/*
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IoCLI_DEFINED
#define IoCLI_DEFINED 1

#include "IoState.h"
#include "CLI.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
    IoState *state;
    CLI *cli;
    unsigned char didPrint;
} IoCLI;

IoCLI *IoCLI_new(void);
void IoCLI_free(IoCLI *self);

void IoCLI_state_(IoCLI *self, IoState *state);

int IoCLI_main(IoCLI *self, int argc, const char *argv[]);
void IoCLI_runFile_(IoCLI *self, const char *s);
IoObject *IoCLI_run(IoCLI *self);
void IoCLI_cliInput(IoCLI *self, const char *s);

/* --- callbacks -------------------------- */
void IoCLI_print_(IoCLI *self, const char *s);

#ifdef __cplusplus
}
#endif
#endif
