/*#io
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IOOBJECT_ACTOR_DEFINED 
#define IOOBJECT_ACTOR_DEFINED 1

#include "Common.h"
#include "ByteArray.h"
#include "IoObject.h"
#include "IoCoroutine.h"

#ifdef __cplusplus
extern "C" {
#endif

void IoObject_markActor(IoObject *self);

void IoObject_createCoroIfAbsent(IoObject *self);

IoObject *IoObject_actorPerform(IoObject *volatile self, 
    IoObject *locals, 
    IoMessage *m, 
    int returnFuture);
    
IoObject *IoObject_asyncPerform(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoObject_futurePerform(IoObject *self, IoObject *locals, IoMessage *m);
void IoObject_run(void *context);

void IoObject_yield(IoObject *self); /* private! */
void IoObject_abort(IoObject *self);

void IoObject_prepareToPause(IoObject *self);
void IoObject_pause(IoObject *self);
unsigned int IoObject_isPaused(IoObject *self);
void IoObject_resume(IoObject *self);
unsigned int IoObject_isPausing_(IoObject *self, IoObject *other);

/* --- proto ---------------------------------- */

IoObject *IoObject_actorYield(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoObject_actorResume(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoObject_actorPause(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoObject_currentActor(IoObject *self, IoObject *locals, IoMessage *m);

void IoObject_prepareToUnyield(IoObject *self);

IoObject *IoObject_isActive(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoObject_actorWait(IoObject *self, IoObject *locals, IoMessage *m);

/* --- stack trace -------------------------------- */

int IoObject_isBlockLocals(IoObject *self);
IoObject *IoObject_callStack(IoObject *self);

IoObject *IoObject_try(IoObject *self, IoObject *locals, IoMessage *m);

ByteArray *IoObject_backTraceOnCallStackDescription_(IoObject *self, IoObject *calls);

#ifdef __cplusplus
}
#endif
#endif
