Importer := Object clone do(
    paths := List clone add("")
    debug := Nil
    addSearchPath := method(p, paths add(p))
    extensions := list("io")

    executeString := method(name, s,
	Lobby doString(s)
	r := Lobby getSlot(name)
	if(r, return r)
	Exception raise("Importer", "slot '" .. name .. "' missing after file load")
	Nil    
    )
    
    execute_io := method(path, name, extension,
	p := Path with(path, name .. "." .. extension)
	s := File clone setPath(p) asBuffer
	executeString(name, s)
    )

    find := method(name, theObject,
	p := ?launchPath
	if(p and paths contains(p) == Nil, paths atInsert(0, p))  
	if(name at(0) isUpperCase, paths foreach(p, 
	    extensions foreach(extension,
		fullPath := Path with(p, name .. "." .. extension)
		if(debug, write("Importer search:", p, "\n"))
		if(File clone setPath(fullPath) exists, 
		    r := self perform("execute_" .. extension, p, name, extension)
		    if (r, return r)
		)
	    )
	  )
	)
	Exception raise("Importer", theObject type .. " does not respond to '" .. name .. "'")
    )
    
    turnOn := method(Lobby forward := method(Importer find(thisMessage name, self)))
    turnOff := method(Lobby removeSlot("forward"))
    turnOn
)