/*   
 *   copyright: Steve Dekorte, 2002. All rights reserved.
 *   license: See _BSDLicense.txt.
 *
 */

#ifndef IOLOCALS_DEFINED
#define IOLOCALS_DEFINED 1

#include "Common.h"
#include "List.h"
#include "IoObject.h"
#include "IoState.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ISLOCALS(self) IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoLocals_rawClone)

typedef IoObject IoLocals;

typedef struct
{
    IoObject *target;
    IoObject *self;
    IoObject *sender;
    IoObject *thisBlock;
    IoObject *thisMessage;
} IoLocalsData;

IoLocals *IoLocals_proto(void *state);
IoLocals *IoLocals_rawClone(IoLocals *self);
IoLocals *IoLocals_new(IoState *state);
void IoLocals_mark(IoLocals *self);
void IoLocals_free(IoLocals *self);

void IoLocals_writeToStore_stream_(IoLocals *self, IoStore *store, BStream *stream);
void IoLocals_readFromStore_stream_(IoLocals *self, IoStore *store, BStream *stream);

/* ---  ----------------------------------------------- */

IoObject *IoLocals_target(IoLocals *self, IoObject *locals, IoMessage *m);
IoObject *IoLocals_self(IoLocals *self, IoObject *locals, IoMessage *m);
IoObject *IoLocals_sender(IoLocals *self, IoObject *locals, IoMessage *m);
IoObject *IoLocals_thisBlock(IoLocals *self, IoObject *locals, IoMessage *m);
IoObject *IoLocals_thisMessage(IoLocals *self, IoObject *locals, IoMessage *m);

#ifdef __cplusplus
}
#endif
#endif
