/*#io
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IoPMap_DEFINED
#define IoPMap_DEFINED 1

#include "Common.h"
#include "IoObject.h"
#include "IoList.h"
#include "SkipDB.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ISPERSISTENTMAP(self) IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoPMap_rawClone)

typedef IoObject IoMap;

IoMap *IoPMap_proto(void *state);
IoMap *IoPMap_rawClone(IoMap *self);
IoMap *IoPMap_new(void *state);
void IoPMap_free(IoMap *self);
void IoPMap_mark(IoMap *self);
Hash *IoPMap_rawHash(IoMap *self);

void IoPMap_writeToStore_stream_(IoMap *self, IoStore *store, BStream *stream);
void IoPMap_readFromStore_stream_(IoMap *self, IoStore *store, BStream *stream);

/* ----------------------------------------------------------- */

IoObject *IoPMap_empty(IoMap *self, IoObject *locals, IoMessage *m);

IoObject *IoPMap_rawAt(IoMap *self, IoSymbol *k);
IoObject *IoPMap_at(IoMap *self, IoObject *locals, IoMessage *m);

void IoPMap_rawAtPut(IoMap *self, IoSymbol *k, IoObject *v);
IoObject *IoPMap_atPut(IoMap *self, IoObject *locals, IoMessage *m);
IoObject *IoPMap_atIfAbsentPut(IoMap *self, IoObject *locals, IoMessage *m);
IoObject *IoPMap_removeAt(IoMap *self, IoObject *locals, IoMessage *m);
IoObject *IoPMap_size(IoMap *self, IoObject *locals, IoMessage *m);

IoObject *IoPMap_hasKey_(IoMap *self, IoObject *locals, IoMessage *m);
IoObject *IoPMap_hasValue_(IoMap *self, IoObject *locals, IoMessage *m);

IoList *IoPMap_rawKeys(IoMap *self);
IoObject *IoPMap_keys(IoMap *self, IoObject *locals, IoMessage *m);

IoObject *IoPMap_values(IoMap *self, IoObject *locals, IoMessage *m);
IoObject *IoPMap_foreach(IoMap *self, IoObject *locals, IoMessage *m);

#ifdef __cplusplus
}
#endif
#endif
