sampleCode := """
BigFolder := Object clone do(
  
    newSlot("path", ".")
    
    rootFolder := method(
	Directory clone setPath(path)
    )
    
    fileNamed := method(name,
	path := Buffer clone
	max := name size - 1
	
	folder := rootFolder
	
	title  := name beforeSeq(".")
	suffix := name afterSeq(".")
	
	paths := title asCharacterStringList
	fileName := paths last .. "." .. suffix
	paths removeLast
	
	paths foreach(i, folderName, 
	    folder:= folder folderNamedCreateIfAbsent(folderName)
	)
	
	File clone setPath(Path with(folder path, fileName))
    )
)
BigFolder := Object clone do(
  
    newSlot("path", ".")
    
    rootFolder := method(
	Directory clone setPath(path)
    )
    
    fileNamed := method(name,
	path := Buffer clone
	max := name size - 1
	
	folder := rootFolder
	
	title  := name beforeSeq(".")
	suffix := name afterSeq(".")
	
	paths := title asCharacterStringList
	fileName := paths last .. "." .. suffix
	paths removeLast
	
	paths foreach(i, folderName, 
	    folder:= folder folderNamedCreateIfAbsent(folderName)
	)
	
	File clone setPath(Path with(folder path, fileName))
    )
)


"""

s := Buffer clone
pagesPerCompile := 100
for(i, 0, pagesPerCompile, s appendSeq(sampleCode))

d1 := Date clone now
compileCount := 20
compileCount repeatTimes(s asMessage)
seconds := Date clone now secondsSince(d1)
writeln((compileCount * pagesPerCompile/ seconds) floor , " pages per second")
writeln((seconds/ (compileCount * pagesPerCompile)) * 1000, " miliseconds per page ")

// 1026/sec for no inlines
// 1000/sec with inlines