
max = 300000000

results = {}

function New(parent)
    local v = {}
    v.__index = v
    return setmetatable(v, parent)
end

Tester = New({})

function Tester:new() 
    return setmetatable({}, self) 
end

function Tester:foo()
    return 1
end

function Tester:beginTimer()
	self.t1 = os.time()
end
    
function Tester:endTimer(s, rmax)
	if rmax == nil then rmax = max end
	local t2 = os.time()
	local dt = (tonumber(t2) - tonumber(self.t1))
	local mps = (rmax / dt)/1000000.0
	--print("t1 " .. self.t1)
	--print("t2 " .. t2)
	--print("dt " .. dt)
	print("Lua " .. s .. " := " .. mps)
end
    
function Tester:testSlot()
	self:beginTimer()
	self.x = 1
	for i = 1, max, 8 do
	    a = self.x
	    a = self.x
	    a = self.x
	    a = self.x
	    a = self.x
	    a = self.x
	    a = self.x
	    a = self.x
	end
	self:endTimer("slotAccesses      ")
end

function Tester:testSetSlot()
	self:beginTimer()
	self.x = 1
	for i = 1, max, 8 do
	   x = 1
	   x = 1
	   x = 1
	   x = 1
	   x = 1
	   x = 1
	   x = 1
	   x = 1
	end
	self:endTimer("slotSets          ")
end
    
function Tester:testBlock()
	self:beginTimer()
	for i = 1, max, 8 do
	   self:foo()
	   self:foo()
	   self:foo()
	   self:foo()
	   self:foo()
	   self:foo()
	   self:foo()
	   self:foo()	   
	end
	self:endTimer("blockActivations  ")
end
    
function Tester:testInstantiations()
	local rmax = max / 10
	self:beginTimer()
	for i = 1, rmax, 8 do
	    Tester:new()
	    Tester:new()
	    Tester:new()
	    Tester:new()
	    Tester:new()
	    Tester:new()
	    Tester:new()
	    Tester:new()
	end
	self:endTimer("instantiations    ", rmax)
end

function Tester:testLocals()
	self:beginTimer()
	local v = 1
	local a = 1
	for i = 1, max, 8 do
	    a = v
	    a = v
	    a = v
	    a = v
	    a = v
	    a = v
	    a = v
	    a = v
	end
	self:endTimer("localAccesses     ")
end

function Tester:testSetLocals()
	self:beginTimer()
	local v = 0
	for i = 1, max, 8 do
	    v = 1
	    v = 2
	    v = 3
	    v = 4
	    v = 1
	    v = 2
	    v = 3
	    v = 4
	end
	self:endTimer("localSets         ")
end

function Tester:test()
	print("\n")
	self:testLocals()
	self:testSetLocals()
	print("\n")
	self:testSlot()
	self:testSetSlot()
	print("\n")
	self:testBlock()
	self:testInstantiations()
	print("Lua version = \"" .. _VERSION .. "\"")
	print("\n")
	print("// values in millions per second\n")
end

Tester:new():test()

