MAX := 400

// ----------------------------

SFIX := 100000000
PFIX := SFIX * MAX

s := Date secondsToRun(for(i, 0, MAX, for(j, 0, MAX, j asString)))
writeln("normal: ",  (MAX*MAX/s) floor, " strings/sec")

s := Date secondsToRun(for(i, 0, MAX, for(j, 0, MAX, (j * SFIX) asString)))
writeln("suffix: ",  (MAX*MAX/s) floor, " strings/sec")

s := Date secondsToRun(for(i, 0, MAX, for(j, 0, MAX, (PFIX + j) asString)))
writeln("prefix: ",  (MAX*MAX/s) floor, " strings/sec")

s := Date secondsToRun(for(i, 0, MAX, for(j, 0, MAX, ((PFIX + j) * SFIX) asString)))
writeln("both:   ",  (MAX*MAX/s) floor, " strings/sec")

/*

--- with ----

normal: 430167 strings/sec
suffix: 253524 strings/sec
prefix: 293291 strings/sec
both:   272159 strings/sec

--- without ----

normal: 431299 strings/sec
suffix: 218891 strings/sec
prefix: 270028 strings/sec
both:   234391 strings/sec

*/